const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const game_payments = sequelize.define(
    'game_payments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

fee_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

payment_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"unpaid",


"paid",


"exempt"

        ],

      },

payment_method: {
        type: DataTypes.ENUM,
      
      

        values: [

"stripe",


"cash",


"exempt"

        ],

      },

stripe_payment_reference: {
        type: DataTypes.TEXT,
      
      

      },

paid_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  game_payments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.game_payments.belongsTo(db.games, {
      as: 'game',
      foreignKey: {
        name: 'gameId',
      },
      constraints: false,
    });

    db.game_payments.belongsTo(db.players, {
      as: 'player',
      foreignKey: {
        name: 'playerId',
      },
      constraints: false,
    });

    db.game_payments.belongsTo(db.game_guests, {
      as: 'guest',
      foreignKey: {
        name: 'guestId',
      },
      constraints: false,
    });

    db.game_payments.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.game_payments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.game_payments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return game_payments;
};


